//show the behavior of diabling resize callback and move the defining of viewport and stuff into display callback
//show change of glTranslatef(0, 0, -10)
//show change of glVertex3f
//show change of idle function, diable the loadIdentity in the display function

#include <windows.h>
#include <GL/glut.h>
#include <iostream>
using namespace std;

static void resize(int width, int height)
{
	const float ar = (float) width / (float) height;

	glViewport(0, 0, width, height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glFrustum(-ar, ar, -1.0, 1.0, 2.0, 100.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity() ;
}

static void display(void)
{
	glClearDepth(1.0f);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	glShadeModel(GL_FLAT);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	//glLoadIdentity(); //disable this when demo animation
	glTranslatef(0,0,-10); //translate in the z direction
	glColor3f(1,0,0);
	//glutSolidTeapot(1);
	glBegin(GL_QUADS);
	glVertex3f(-1.0f, -1.0f, 1.0f);
	glVertex3f( 1.0f, -1.0f, 1.0f);
	glVertex3f( 1.0f, 1.0f, 1.0f);
	glVertex3f(-1.0f, 1.0f, 1.0f);
	glEnd();
	
	glutSwapBuffers(); //very important!!!
}

static void idle(void)
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

	static float dx = 0.0;
	static float dz = 0.0;
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslatef(dx,0,dz); //translate in the z direction

	dx +=.005;
	dz +=.01;

	//glutPostRedisplay();
	cout<<"calling idle function"<<endl;
	
}

int main(int argc, char *argv[])
{
	glutInit(&argc, argv);
	glutInitWindowSize(640,480);
	glutInitWindowPosition(10,10);
	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);

	glutCreateWindow("Glut Tutorial");

	//register callback functions
	glutReshapeFunc(resize);
	glutDisplayFunc(display);
	glutIdleFunc(idle);

	glClearColor(1,1,1,1);

	glutMainLoop();

	return EXIT_SUCCESS;
}
